JeuxVideos/JeuxVideos/urls.py
from django.contrib import admin
from django.urls import path, include
from lesJeux import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('lesJeux/', include('lesJeux.urls'))
]

JeuxVideos/lesJeux/urls.py
from django.urls import path
from .views import *
from . import views
from django.views.generic import RedirectView

app_name = 'lesJeux' # Encapsule les urls de ce module dans le namespace musique
urlpatterns = [
    path('<int:pk>', JeuDetailView.as_view(), name='jeu-detail'),
    path('jeu', JeuList.as_view(), name='jeu_list'),
    path('jeu/create', JeuCreate.as_view(), name='jeu_create'),
    path('<int:pk>/delete/', JeuDelete.as_view(), name='jeu-delete'),
    path('jeu/<int:pk>', JeuUpdate.as_view(), name='jeu_update'),
    path('', JeuList.as_view(), name='jeu_list'),


    path('editeur/', EditeurList.as_view(), name='editeur_list'),
    path('editeur/<int:pk>', EditeurDetailView.as_view(), name='editeur-detail'),
    path('editeur/create', EditeurCreate.as_view(), name='editeur_create'),
    path('editeur/<int:pk>/delete/', EditeurDelete.as_view(), name='editeur-delete'),
    path('editeur/<int:pk>/update', EditeurUpdate.as_view(), name='editeur_update'),

    path('personnage/', PersonnageList.as_view(), name='personnage_list'),
    path('personnage/<int:pk>', PersonnageDetailView.as_view(), name='personnage-detail'),
    path('personnage/create', PersonnageCreate.as_view(), name='personnage_create'),
    path('personnage/<int:pk>/delete/', PersonnageDelete.as_view(), name='personnage-delete'),
    path('personnage/<int:pk>/update', PersonnageUpdate.as_view(), name='personnage_update'),
    path('jeu/create/personnage', PersonnageCreate2.as_view(),name='personnage_create2')
]

JeuxVideos/lesJeux/models.py
from django.db import models
from datetime import datetime, timedelta, date
from django.utils.html import format_html
from django.utils import formats
from django.urls import reverse
from django.core.exceptions import ValidationError
from fuzzywuzzy.fuzz import ratio

def get_partie_commune(nom1, nom2):
    # ex:   nom1 => star wars 2 ;  nom2 => star wars le retour
    #       donne => star wars
    partie_commune = ""
    minimum = min(nom1, nom2)
    for i in range(len(minimum)):
        if nom1[i] == nom2[i]:
            partie_commune += minimum[i]
    return partie_commune

def get_ratio_lettres_nom(nom1, nom2):
    # donne le ratio (en %) de lettres identiques entre nom1 et nom2
    return ratio(nom1, nom2)


def validate_date_inferieur_demain(value):
    if value > date.today():
        raise ValidationError(
            ("Les dates dans le futur ne sont pas permises"),
            params={"value": value},
        )
    
def validate_jeu_nom_presque_unique(nom): 
    # faute d'orthographe star wars <> star wors
    nom_existant = Jeu.objects.filter(nom__istartswith=nom.split(" ")[0])# on prend le premier mot

    if str(len(nom_existant)+1) in nom:
        print(nom)
        print("POUET")
    elif nom_existant.exists():
        raise ValidationError(
            # nom_existant est un QuerySet
            f"Le Jeu '{nom_existant[len(nom_existant)-1]}' existe. Essayer avec '{get_partie_commune(nom, nom_existant[0].get_nom())} {len(nom_existant)+1}'",
            params={"value": nom},
        )
    elif get_ratio_lettres_nom(nom, nom_existant[0].get_nom()) > 75: # 75 % , ~ 2 lettres
        raise ValidationError(
            # nom_existant est un QuerySet
            f"Avez vous essayé d'écrire '{nom_existant[len(nom_existant)-1]}' ? Sinon ré-appuyer sur 'Submit   '",
            params={"value": nom},
        )
    
        
class Personnage(models.Model):
    nom = models.CharField(max_length=250, unique=True)
    age = models.CharField(max_length=250, null=True)
    
    def __str__(self):
        return self.nom
    
    def get_absolute_url(self):
        return reverse('lesJeux:personnage-detail', kwargs={'pk': self.pk})

    # Getters
    def get_nom(self):
        return self.nom

    def get_age(self):
        return self.age
    
  
    # Setters
    def set_name(self, nom):
        self.nom = nom
        self.save()

    def set_age(self, age):
        self.age = age
        self.save()
    
  
class Editeur(models.Model):
    nom = models.CharField(max_length=250, unique=True)
    date_creation = models.DateField(null=True,  validators=[validate_date_inferieur_demain])
    logo = models.URLField()
   
    def __str__(self):
        return self.nom
    
    def get_absolute_url(self):
        return reverse('lesJeux:editeur-detail', kwargs={'pk': self.pk})

    # Getters
    def get_nom(self):
        return self.nom
    
    def get_date_creation(self):
        return self.date_creation

    def get_logo(self):
        return self.logo
    
    # Setters
    def set_name(self, nom):
        self.nom = nom
        self.save()
    
    def set_date_creation(self, date_creation):
        self.date_creation = date_creation
        self.save()

    def set_logo(self, logo):
        self.editlogoeur = logo
        self.save()


class Jeu(models.Model):
    nom = models.CharField(max_length=250, unique=True, validators=[validate_jeu_nom_presque_unique])
    description = models.TextField()
    genre = models.CharField(max_length=250)
    prix = models.IntegerField()
    editeur = models.ForeignKey(Editeur, on_delete=models.CASCADE, related_name="editeur", null=True)
    date_creation = models.DateField(null=True, validators=[validate_date_inferieur_demain])
    personnages = models.ManyToManyField(Personnage, related_name="personnages", null=True, blank=True)
    logo = models.URLField(null=True)
    url_steam = models.URLField(null=True)

    def __str__(self):
        return self.nom
    
    def get_absolute_url(self):
        return reverse('lesJeux:jeu-detail', kwargs={'pk': self.pk})

    # Getters
    def get_nom(self):
        return self.nom

    def get_description(self):
        return self.description
    
    def get_genre(self):
        return self.genre
    
    def get_prix(self):
        return self.prix
    
    def get_editeur(self):
        return self.editeur
    
    def get_date_creation(self):
        return self.date_creation
    
    def get_personnages(self):
         return self.personnages
    
    # Setters
    def set_name(self, nom):
        self.nom = nom
        self.save()

    def set_description(self, description):
        self.description = description
        self.save()

    def set_genre(self, genre):
        self.genre = genre
        self.save()

    def set_prix(self, prix):
        self.prix = prix
        self.save()

    def set_editeur(self, editeur):
        self.editeur = editeur
        self.save()

    def set_personnages(self, personnages):
         self.personnages = personnages
         self.save()

    def set_date_creation(self, date_creation):
        self.date_creation = date_creation
        self.save()

JeuxVideos/lesJeux/views.py
from django.shortcuts import render, redirect
from django.http import HttpResponse
from django.views.generic import DetailView, ListView, CreateView, DeleteView, UpdateView
from .models import Jeu,Editeur, Personnage
from django.urls import reverse_lazy
from django.forms import DateInput, CharField,ModelMultipleChoiceField,CheckboxSelectMultiple
from django import forms
from django.contrib.admin.widgets import AdminDateWidget
from django.db import models
from django.urls import reverse


class JeuForm(forms.ModelForm):
    personnages = forms.ModelMultipleChoiceField(
            queryset=Personnage.objects.all(),
            widget=forms.CheckboxSelectMultiple,
            required=False
        )
    nom = forms.CharField()
    description = forms.CharField()
    genre = forms.CharField()
    prix = forms.CharField()
     
    class Meta:
        model= Jeu
        fields = ['nom', 'description', 'genre', 'prix','editeur', 'date_creation','personnages','logo','url_steam']
        
        
        

class JeuDetailView(DetailView):
    model = Jeu

class JeuList(ListView):
    model = Jeu

class JeuCreate(CreateView):
    model = Jeu
    form_class= JeuForm
    template_name= 'lesJeux/jeu_form.html'
     
    def get_form(self, form_class=None):
        form = super(JeuCreate, self).get_form(form_class)
        form.fields['date_creation'].widget = AdminDateWidget(attrs={'type': 'date'})
        return form

class JeuDelete(DeleteView):
    model = Jeu
    success_url = reverse_lazy('lesJeux:jeu_list')

class JeuUpdate(UpdateView):
    model = Jeu
    form_class= JeuForm
    template_name_suffix = '_update_form'

    def get_form(self, form_class=None):
        form = super(JeuUpdate, self).get_form(form_class)
        form.fields['date_creation'].widget = AdminDateWidget(attrs={'type': 'date'})
        return form

class EditeurDetailView(DetailView):
    model = Editeur

class EditeurList(ListView):
    model = Editeur

class EditeurCreate(CreateView):
    model = Editeur
    fields = ['nom', 'date_creation', 'logo']
   
    def get_form(self, form_class=None):
        form = super(EditeurCreate, self).get_form(form_class)
        form.fields['date_creation'].widget = AdminDateWidget(attrs={'type': 'date'})
        return form

class EditeurDelete(DeleteView):
    model = Editeur
    success_url = reverse_lazy('lesJeux:editeur_list')

class EditeurUpdate(UpdateView):
    model = Editeur
    fields = ['nom', 'date_creation', 'logo']
    template_name_suffix = '_update_form'

    def get_form(self, form_class=None):
        form = super(EditeurUpdate, self).get_form(form_class)
        form.fields['date_creation'].widget = AdminDateWidget(attrs={'type': 'date','placeholder':form.fields['date_creation']})
        return form
class PersonnageDetailView(DetailView):
    model = Personnage
    
class PersonnageList(ListView):
    model = Personnage

class PersonnageCreate(CreateView):
    model = Personnage
    fields = ['nom','age']
    
    
    # def get_form(self, form_class=None):
    #     formu= super(PersonnageCreate, self).get_form(form_class)
        
    #     CHOICES = FormsTools.JeuxToTuples(Jeu.objects.all())
        
    #     formu.fields['jeux'].widget = forms.ChoiceField(forms.MultipleChoiceField( required=True, widget=forms.CheckboxSelectMultiple(), choices=CHOICES),)
    #     return formu
   
class PersonnageDelete(DeleteView):
    model = Personnage
    success_url = reverse_lazy('lesJeux:personnage_list')

class PersonnageUpdate(UpdateView):
    model = Personnage
    fields = ['nom','age']
    template_name_suffix = '_update_form'

class PersonnageCreate2(CreateView):
    model = Personnage
    fields = ['nom','age']
    success_url = reverse_lazy('lesJeux:jeu_create')

JeuxVideos/lesJeux/templates/lesJeux/editeur_confirm_delete.html
<form method="post">{% csrf_token %}
    <p>Etes-vous sur de vouloir supprimer "{{ object }}"?</p>
    <input type="submit" value="Confirmer">
</form>

JeuxVideos/lesJeux/templates/lesJeux/editeur_detail.html
{% extends "baseLayout.html" %}

{% load static %}

{% block title %}
Editeur
{% endblock %}

{% block styles %}
    {{ block.super }}
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css"
integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU"
crossorigin="anonymous">

{% endblock %}

{% block content %}
<div class="container mt-4">
    <div class="card">
        <div class="card-header">
            Détails de l'éditeur
        </div>
        <div class="card-body">
            <ul class="list-group list-group-flush">
                <li class="list-group-item"><strong>Nom:</strong> {{object.nom}}</li>
                <li class="list-group-item"><strong>Date de création:</strong> {{object.date_creation}}</li>
                <li class="list-group-item"><strong>Logo:</strong> {{object.logo}}</li>
            
            </ul>
        </div>
        <div class="card-footer">
            <a href="{% url 'lesJeux:editeur_list' %}">
                Revenir a la liste des Editeurs
            </a>
        </div>
    </div>
</div>

   
{% endblock %}

JeuxVideos/lesJeux/templates/lesJeux/editeur_form.html
{% extends "baseLayout.html" %}

{% block header %}
           <h2>Editeur</h2>
{% endblock %}

{% block content %}
<form method="post">{% csrf_token %}
    {{ form.as_p }}
    <input type="submit" value="Save">
</form>

{% endblock %}

JeuxVideos/lesJeux/templates/lesJeux/editeur_list.html
{% extends "baseLayout.html" %}

{% load static %}

{% block title %}
Editeurs
{% endblock %}

{% block styles %}
    {{ block.super }}
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css"
integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU"
crossorigin="anonymous">

{% endblock %}

{% block content %}
<h2>Editeurs</h2>
<div class="card bg-secondary">
    <div class="card-body">
      <div class="row" style="row-gap: 1rem">
        {% if editeur_list %}
          {% for editeur in editeur_list %}
            <div class="col-sm-6 col-lg-4 col-xl-3">
              <div class="card bg-light text-dark">
                <h5 class="card-header">
                  {{ editeur.nom }}
                </h5>
                <div class="card-body">
                  <img src="{{editeur.logo}}" alt="Logo" class="img-fluid rounded">
                </div>
                <div class="card-footer d-flex justify-content-end" style="column-gap: 1rem">
                    <a href="{% url 'lesJeux:editeur-detail' editeur.id %}" class="btn btn-secondary"><i class="fas fa-eye"></i></a>
                    <a href="{% url 'lesJeux:editeur_update' editeur.id %}" class="btn btn-primary"><i class="fas fa-pen"></i></a>
                    <a href="{% url 'lesJeux:editeur-delete' editeur.id %}" class="btn btn-danger"><i class="fas fa-trash"></i></a>
                  </div>
              </div>
            </div>
          {% endfor %}
        {% else %}
          <h4 class="container text-warning">Aucun Editeur !</h4>
        {% endif %}
      </div>
    </div>
  </div>
  <a href="{% url 'lesJeux:editeur_create' %}" class="btn btn-success mt-3">Ajouter un Editeur</a>
  <a href="{% url 'lesJeux:jeu_list'  %}"  class="btn btn-primary mt-3">Voir les Jeux</a>
  <a href="{% url 'lesJeux:personnage_list'  %}"  class="btn btn-primary mt-3">Voir les Personnages</a>

     
{% endblock %}

JeuxVideos/lesJeux/templates/lesJeux/editeur_update_form.html
{% extends "baseLayout.html" %}

{% block header %}
           <h2>Mise à jour de l'Editeur</h2>
{% endblock %}

{% block content %}
<form method="post">{% csrf_token %}
    {{ form.as_p }}
    <input type="submit" value="Update">
</form>

{% endblock %}

JeuxVideos/lesJeux/templates/lesJeux/jeu_confirm_delete.html
<form method="post">{% csrf_token %}
    <p>Etes-vous sur de vouloir supprimer "{{ object }}"?</p>
    <input type="submit" value="Confirmer">
</form>

JeuxVideos/lesJeux/templates/lesJeux/jeu_detail.html
{% extends "baseLayout.html" %}

{% load static %}

{% block title %}
Jeu
{% endblock %}

{% block styles %}
    {{ block.super }}
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css"
integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU"
crossorigin="anonymous">

{% endblock %}

{% block content %}
 <div class="container mt-4">
        <div class="card">
            <div class="card-header">
                Détails du Jeu
            </div>
            <div class="card-body">
                <ul class="list-group list-group-flush">
                    <li class="list-group-item"><strong>Nom: </strong> {{object.nom}}</li>
                    <li class="list-group-item"><strong>Description: </strong> {{object.description}}</li>
                    <li class="list-group-item"><strong>Genre: </strong> {{object.genre}}</li>
                    <li class="list-group-item"><strong>Prix: </strong> {{object.prix}}</li>
                    <li class="list-group-item"><strong>Date de création: </strong> {{object.date_creation}}</li>
                    <li class="list-group-item"><strong>Editeur: </strong> {{object.editeur}}</li>
                    <li class="list-group-item"><strong>Logo: </strong> {{object.logo}}</li>
                    <li class="list-group-item"><strong>Url Steam: </strong><a href="{{object.url_steam}}">{{object.url_steam}}</a></li>

                    <ul>
                        <h4>Les Personnages:</h4>
                        {% for personnage in jeu.personnages.all %}
                        <li>{{ personnage.nom }}</li>
                        {% endfor %}
                    </ul>
                   
                </ul>
            </div>
            <div class="card-footer">
                <a href="{% url 'lesJeux:jeu_list' %}">
                    Revenir a la liste
                </a>
            </div>
        </div>
    </div>
{% endblock %}

JeuxVideos/lesJeux/templates/lesJeux/jeu_form.html
{% extends "baseLayout.html" %}

{% block header %}
           <h2>Jeu</h2>
{% endblock %}

{% block content %}
	
{% if envoi %}
 
Votre Jeu a bien été envoyé !
 
{% endif %}
 
<form action="create" method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <p>Pour ajouter un Personnage, Contacter un administrateur</p>
    <a href="{% url 'lesJeux:personnage_create2' %}" class="btn btn-success ">Ajouter un Personnage</a>

    <input class="btn btn-primary" type="submit" value="Submit" />
</form>
{% endblock %}

JeuxVideos/lesJeux/templates/lesJeux/jeu_list.html
{% extends "baseLayout.html" %}

{% load static %}

{% block title %}
Jeux
{% endblock %}

{% block styles %}
    {{ block.super }}
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css"
integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU"
crossorigin="anonymous">

{% endblock %}

{% block content %}
<h2>Jeux</h2>
<div class="card bg-secondary">
    <div class="card-body">
      <div class="row" style="row-gap: 1rem">
        {% if jeu_list %}
          {% for jeu in jeu_list %}
            <div class="col-sm-6 col-lg-4 col-xl-3">
              <div class="card bg-light text-dark">
                <h5 class="card-header">
                  {{ jeu.nom }} par  {{ jeu.editeur }}
                </h5>
                <div class="card-body">
                  <img src="{{jeu.logo}}" alt="Logo" class="img-fluid rounded mx-auto d-block" style="width:45%; height:auto ">
                </div>
                <div class="card-footer d-flex justify-content-end" style="column-gap: 1rem">
                    <a href="{% url 'lesJeux:jeu-detail' jeu.id %}" class="btn btn-secondary"><i class="fas fa-eye"></i></a>
                    <a href="{% url 'lesJeux:jeu_update' jeu.id %}" class="btn btn-primary"><i class="fas fa-pen"></i></a>
                    <a href="{% url 'lesJeux:jeu-delete' jeu.id %}" class="btn btn-danger"><i class="fas fa-trash"></i></a>
                    <a href="{{jeu.url_steam}}" class="btn btn-info"><img src="https://upload.wikimedia.org/wikipedia/commons/thumb/8/83/Steam_icon_logo.svg/800px-Steam_icon_logo.svg.png" alt="Logo steam" class="img-fluid rounded" style="width:45%; height:auto"></a>
                  </div>
              </div>
            </div>
          {% endfor %}
        {% else %}
          <h4 class="container text-warning">Aucun jeu !</h4>
        {% endif %}
      </div>
    </div>
  </div>
  <a href="{% url 'lesJeux:jeu_create' %}" class="btn btn-success mt-3">Ajouter un jeu</a>
  <a href="{% url 'lesJeux:editeur_list'  %}"  class="btn btn-primary mt-3">Voir les Editeurs</a>
  <a href="{% url 'lesJeux:personnage_list'  %}"  class="btn btn-primary mt-3">Voir les Personnages</a>

     
{% endblock %}

JeuxVideos/lesJeux/templates/lesJeux/jeu_update_form.html
{% extends "baseLayout.html" %}

{% block header %}
           <h2>Mise à jour du Jeu</h2>
{% endblock %}

{% block content %}
<form method="post">{% csrf_token %}
    {{ form.as_p }}
    <input type="submit" value="Update">
</form>

{% endblock %}

JeuxVideos/lesJeux/templates/lesJeux/personnage_detail.html
{% extends "baseLayout.html" %}

{% load static %}

{% block title %}
Personnage
{% endblock %}

{% block styles %}
    {{ block.super }}
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css"
integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU"
crossorigin="anonymous">

{% endblock %}

{% block content %}
  

    <div class="container mt-4">
        <div class="card">
            <div class="card-header">
                Détails du Personnage
            </div>
            <div class="card-body">
                <ul class="list-group list-group-flush">
                    <li class="list-group-item"><strong>Nom: </strong> {{object.nom}}</li>
                    <li class="list-group-item"><strong>Age: </strong> {{object.age}}</li>
                   
                </ul>
            </div>
            <div class="card-footer">
                <a href="{% url 'lesJeux:personnage_list' %}">
                    Revenir a la liste des Personnages
                </a>
            </div>
        </div>
    </div>
{% endblock %}

JeuxVideos/lesJeux/templates/lesJeux/personnage_form.html
{% extends "baseLayout.html" %}

{% block header %}
           <h2>Personnage</h2>
{% endblock %}

{% block content %}
<form method="post">{% csrf_token %}
    {{ form.as_p }}
    <input type="submit" value="Save">
</form>

{% endblock %}

JeuxVideos/lesJeux/templates/lesJeux/personnage_list.html
{% extends "baseLayout.html" %}

{% load static %}

{% block title %}
Personnages
{% endblock %}

{% block styles %}
    {{ block.super }}
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css"
integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU"
crossorigin="anonymous">

{% endblock %}

{% block content %}
<h2>Personnages</h2>
<div class="card bg-secondary">
    <div class="card-body">
      <div class="row" style="row-gap: 1rem">
        {% if personnage_list %}
          {% for personnage in personnage_list %}
            <div class="col-sm-6 col-lg-4 col-xl-3">
              <div class="card bg-light text-dark">
                <h5 class="card-header">
                    personnage n°{{personnage.pk}}
                </h5>
                <div class="card-body">
                  <h5 class="card-text"> {{ personnage.nom }}</h5>
                </div>
                <div class="card-footer d-flex justify-content-end" style="column-gap: 1rem">
                    <a href="{% url 'lesJeux:personnage-detail' personnage.id %}" class="btn btn-secondary"><i class="fas fa-eye"></i></a>
                    <a href="{% url 'lesJeux:personnage_update' personnage.id %}" class="btn btn-primary"><i class="fas fa-pen"></i></a>
                    <a href="{% url 'lesJeux:personnage-delete' personnage.id %}" class="btn btn-danger"><i class="fas fa-trash"></i></a>
                  </div>
              </div>
            </div>
          {% endfor %}
        {% else %}
          <h4 class="container text-warning">Aucun Personnage !</h4>
        {% endif %}
      </div>
    </div>
  </div>
  <p>Pour ajouter un Personnage, Contacter un administrateur</p>
  <a href="{% url 'lesJeux:personnage_create' %}" class="btn btn-success mt-3">(Ajouter un Personnage)</a>
  <a href="{% url 'lesJeux:jeu_list'  %}"  class="btn btn-primary mt-3">Voir les Jeux</a>
  <a href="{% url 'lesJeux:editeur_list'  %}"  class="btn btn-primary mt-3">Voir les Editeurs</a>
     
{% endblock %}

JeuxVideos/lesJeux/templates/lesJeux/personnage_update_form.html
{% extends "baseLayout.html" %}

{% block header %}
           <h2>Mise à jour du Personnage</h2>
{% endblock %}

{% block content %}
<form method="post">{% csrf_token %}
    {{ form.as_p }}
    <input type="submit" value="Update">
</form>

{% endblock %}